<?php

// UNITE DE TAILLE DES FICHIER (octets "o", bytes "b")
// (Unit of file size, "o" or "b")

$size_unit="o";

// Police des caractres (letters font)

$font="Verdana";

//-----------------------------------------------------------------------------------------------------------------------------------------
//	FUNCTIONS
//-----------------------------------------------------------------------------------------------------------------------------------------

function taille($fichier)
{
    global $size_unit;
    $taille = filesize($fichier);
    if ($taille >= 1073741824)
    {
        $taille = round($taille / 1073741824 * 100) / 100 . " G".$size_unit;
    }
    elseif ($taille >= 1048576)
    {
        $taille = round($taille / 1048576 * 100) / 100 . " M".$size_unit;
    }
    elseif ($taille >= 1024)
    {
        $taille = round($taille / 1024 * 100) / 100 . " K".$size_unit;
    }
    else
    {
        $taille = $taille . " ".$size_unit;
    }

    if ($taille==0)
    {
        $taille="-";
    }

    return $taille;
}


function date_modif($fichier)
{
    $tmp = filemtime($fichier);
    return date("d/m/Y H:i",$tmp);
}


function slash()
{
    global $racine;
    if (ereg("\\\\",$racine))
    {
        $slash="\\";
    }
    else
    {
        $slash="/";
    }

    return $slash;
}


function deldir($location) 
{ 
    if (is_dir($location))
    {
        $all = opendir($location); 
        while ($file=readdir($all)) 
        { 
            if (is_dir($location.slash().$file) && $file <> ".." && $file <> ".") 
            {
                deldir($location.slash().$file); 
                if (file_exists($location.slash().$file))
                {
                    rmdir($location.slash().$file);
                }

                unset($file); 
            }
            elseif (!is_dir($location.slash().$file))
            { 
                unlink($location.slash().$file); 
                unset($file); 
            } 
        }

        closedir($all);
        rmdir($location);
    }
    else 
    {
        unlink($location);
    }
}


function enlever_controlM($fichier)
{
    $fic = file($fichier);
    $fp = fopen($fichier,"w");
    while (list ($cle, $val) = each ($fic)) 
    {
        $val = str_replace(CHR(10),"",$val);
        $val = str_replace(CHR(13),"",$val);
        fputs($fp,"$val\n");
    }

    fclose($fp);
}


function traite_nom_fichier($nom)
{
    $max_caracteres = 255;
    $nom = stripslashes($nom);
    $nom = str_replace("'","",$nom);
    $nom = str_replace("\"","",$nom);
    $nom = str_replace("\"","",$nom);
    $nom = str_replace("&","",$nom);
    $nom = str_replace(",","",$nom);
    $nom = str_replace(";","",$nom);
    $nom = str_replace("/","",$nom);
    $nom = str_replace("\\","",$nom);
    $nom = str_replace("`","",$nom);
    $nom = str_replace("<","",$nom);
    $nom = str_replace(">","",$nom);
    $nom = str_replace(" ","_",$nom);
    $nom = str_replace(":","",$nom);
    $nom = str_replace("*","",$nom);
    $nom = str_replace("|","",$nom);
    $nom = str_replace("?","",$nom);
    $nom = str_replace("","e",$nom);
    $nom = str_replace("","e",$nom);
    $nom = str_replace("","c",$nom);
    $nom = str_replace("@","",$nom);
    $nom = str_replace("","a",$nom);
    $nom = str_replace("","e",$nom);
    $nom = str_replace("","i",$nom);
    $nom = str_replace("","o",$nom);
    $nom = str_replace("","u",$nom);
    $nom = str_replace("","u",$nom);
    $nom = str_replace("","a",$nom);
    $nom = str_replace("!","",$nom);
    $nom = str_replace("","",$nom);
    $nom = str_replace("+","",$nom);
    $nom = str_replace("^","",$nom);
    $nom = str_replace("(","",$nom);
    $nom = str_replace(")","",$nom);
    $nom = str_replace("#","",$nom);
    $nom = str_replace("=","",$nom);
    $nom = str_replace("$","",$nom);	
    $nom = str_replace("%","",$nom);
    $nom = str_replace("","ae",$nom);
    $nom = str_replace("","Ae",$nom);
    $nom = str_replace("","oe",$nom);
    $nom = str_replace("","Oe",$nom);
    $nom = str_replace("","ue",$nom);
    $nom = str_replace("","Ue",$nom);
    $nom = str_replace("","ss",$nom);
    $nom = substr ($nom,0,$max_caracteres);
    return $nom;
}


//-----------------------------------------------------------------------------------------------------------------------------------------
//	MAIN
//-----------------------------------------------------------------------------------------------------------------------------------------


//-----------------------------------------------------------------------------------------------------------------------------------------
//	DEPLACER / MOVE
//-----------------------------------------------------------------------------------------------------------------------------------------

function moveFile($fic, $dest)
{
    $fic = stripslashes($fic);
    $dest = stripslashes($dest);
    if ($dest!="")
    {
        $destination = $dest.slash();
    }

    $destination .= basename($fic);
    if(file_exists($fic))
    {
        copy($fic,$destination);
    }

    if ($fic!=$destination)
    {
        if (file_exists($fic))
        {
            unlink($fic);
        }
    }

    $messtmp  = "<font face=\"$font\" size=\"2\">\n";
    $messtmp .= sprintf(_GALFILEMOVED, $fic)." <b>"; $err=0;
    if ($dest == "")
    {
        $messtmp.= "/";
    }
    else
    {
        $messtmp.= "$dest";
    }

    $messtmp .= "</b>\n";
    $messtmp .= "</font>\n";
    if ($err != 0)
    {
        return $messtmp;
    }
    else
    {
        return $err;
    }
}

//-----------------------------------------------------------------------------------------------------------------------------------------
//	SUPPRIMER / DELETE
//-----------------------------------------------------------------------------------------------------------------------------------------

function deleteFile($rep, $fic)
{
    $rep = stripslashes($rep);
    $fic = stripslashes($fic);
    $messtmp = "<font face=\"$font\" size=\"2\">";
    $a_effacer = $fic;
    if (file_exists($a_effacer))
    {
        if (is_dir($a_effacer))
        {
            deldir($a_effacer);
            $messtmp .= sprintf(_GALFILEDELETED, $fic);
        }
        else
        {
            unlink($a_effacer);
            $messtmp .= sprintf(_GALFILEDELETED2, $fic);
        }
    }
    else 
    {
        $messtmp .= _GALFILEDELETED3;
    }

    $messtmp .= "</font>";
    return $messtmp;
}


//-----------------------------------------------------------------------------------------------------------------------------------------
//	RENOMMER / RENAME
//-----------------------------------------------------------------------------------------------------------------------------------------

function renameFile($fic)
{
    $err = "";
    $rep = stripslashes($rep);
    $fic = stripslashes($fic);
    $nom_fic = basename($fic);
    $messtmp = "<font face=\"$font\" size=\"2\">";
    $fic_new=traite_nom_fichier($fic_new);
    $old = $racine.slash().$fic;
    $new = dirname($old).slash().$fic_new;
    if ($fic_new=="")
    {
        $messtmp.= _GALFILERENAMED; $err=1;
    }
    else if(file_exists($new))
    {
        $messtmp.=sprintf(_GALFILERENAMED1, $fic_new); $err=1;
    }
    else
    {
        rename($old,$new);
        $messtmp.=sprintf(_GALFILERENAMED2, $fic, $fic_new);
    }

    $messtmp .= "</font>";
    if ($err!=0)
    {
        return $messtmp;
    }
    else
    {
        return $err;
    }
}

	
//-----------------------------------------------------------------------------------------------------------------------------------------
//	CREER UN REPERTOIRE / CREATE DIR
//-----------------------------------------------------------------------------------------------------------------------------------------

function makeDir($rep, $nomdir)
{
    $rep = stripslashes($rep);
    if ($nomdir=="")
    {
        $messtmp .= _GALFILECREATED;
        $err=1;
    }
    else if(file_exists("$rep/$nomdir"))
    {
        $messtmp.=_GALFILECREATED1; $err=1;
    }
    else
    {
        umask(000);
        $ret = mkdir("$rep/$nomdir",0777);
        if ($ret)
        {
            $messtmp .= sprintf(_GALFILECREATED2, $nomdir);
            $messtmp .= "<b>";
            if ($rep=="")
            {
                $messtmp .= "/";
            }
            else
            {
                $messtmp .= "$rep";
            }

            $messtmp .= "</b>";
            $err = 0;
        }
    }

    $messtmp .= "</font>";
    if ($err == 0)
    {
        return $messtmp;
    }
    else
    {
        return $err;
    }
}

	
//-----------------------------------------------------------------------------------------------------------------------------------------
//	UPLOAD
//-----------------------------------------------------------------------------------------------------------------------------------------


function UploadFile($rep, $userfile, $userfile_name, $userfile_size)
{
    global $HTTP_POST_FILES;

    $rep = stripslashes($rep);
    $destination = $rep;
    if ($userfile_size != 0)
    {
        $taille_ko = $userfile_size/1024;
    }
    else
    {
        $taille_ko = 0;
        $err = 1;
    }

    if ($userfile == 'none')
    {
        $message = "Vous n'avez pas s&eacute;lectionn&eacute; de fichier";
        $err=1;
    }

    if (($userfile != 'none' && $userfile_size != 0) || $HTTP_POST_FILES['userfile']['tmp_name'] != '0')
    {
        $userfile_name = traite_nom_fichier($userfile_name);
        if (is_uploaded_file($HTTP_POST_FILES['userfile']['tmp_name']))
        {
            move_uploaded_file($HTTP_POST_FILES['userfile']['tmp_name'], "$destination/" . $HTTP_POST_FILES['userfile']['name']);
            $err = 0;
            $foo = TRUE;
        }
        else
        {
            $err = 2;
        }

        if ($err == '2')
        {
            if (!copy($userfile, "$destination/$userfile_name"))
            {
                $err = 2;
            }
            else
            {
                $err = 0;
                $foo = TRUE;
            }
        }

	if ($foo === TRUE)
        {
            if (eregi('htm|l$ | php|3$ | htaccess$ | pl$ | cgi$ | js$ | htpasswd$', $userfile_name))
            {
                enlever_controlM("$destination/$userfile_name");
            }

            $message = sprintf(_GALFILEUPLOADED1, $userfile_name, $rep);
            $err=0;
        }
    }

    $message .= "$message<br>";	

    return $err;
}

?>
