<?php
/** All misc utility functions
 *
 */

class Util {
	function getDirListAsArray($dirname){
		$dirlist = array();
		$handle=opendir($dirname);
		while (($file = readdir($handle))!==false){
			if (!ereg("^[.]{1,2}$",$file)) {
				$dirlist[]=$file;
			}
		}
		closedir($handle);
		return $dirlist;
	}

	function fixQuotes ($what = "") {
		//#mpn_use_stripslashes
		//# Set to 0 calls the old function
		//# Set to 1 calls StripSlashes($what)
        $what = ereg_replace("'","''",$what);
        while (eregi("\\\\'", $what)) {
			$what = ereg_replace("\\\\'","'",$what);
        }
        return $what;
	}

	function delQuotes($string){
		# no recursive function to add quote to an HTML tag if needed
		# and delete duplicate spaces between attribs.
        $tmp="";    # string buffer
        $result=""; # result string
        $i=0;
        $attrib=-1; # Are us in an HTML attrib ?   -1: no attrib   0: name of the attrib   1: value of the atrib
        $quote=0;   # Is a string quote delimited opened ? 0=no, 1=yes
        $len = strlen($string);
        while ($i<$len) {
			switch($string[$i]) { # What car is it in the buffer ?
			    case "\"": #"       # a quote.
				    if ($quote==0) {
						$quote=1;
					} else {
						$quote=0;
						if (($attrib>0) && ($tmp != "")) {
							$result .= "=\"$tmp\""; 
						}
						$tmp="";
						$attrib=-1;
					}
					break;
				case "=":           # an equal - attrib delimiter
                    if ($quote==0) {  # Is it found in a string ?
                        $attrib=1;
						if ($tmp!="") {
							$result.=" $tmp";
						}
						$tmp="";
					} else {
						$tmp .= '=';
					}
					break;
				case " ":           # a blank ?
				    if ($attrib>0) {  # add it to the string, if one opened.
                        $tmp .= $string[$i];
                    }
					break;
				default:            # Other
                    if ($attrib<0) {  # If we weren't in an attrib, set attrib to 0
                        $attrib=0;
					}
					$tmp .= $string[$i];
					break;
			}
			$i++;
		}
        if (($quote!=0) && ($tmp != "")) {
			if ($attrib==1) {
				$result .= "=";
			}
			# If it is the value of an atrib, add the '='
            $result .= "\"$tmp\"";# Add quote if needed (the reason of the function ;-)
        }
        #  echo $result;echo ".....";
        return $result;
	}

	function filterText($message, $strip="") {
        global $EditedMessage;
        check_words($message);
        $EditedMessage=check_html($EditedMessage, $strip);
        return $EditedMessage;
	}

	/**
	 * Modified by Nathan Codding - July 20, 2000.
	 * Made it only work on URLs and e-mail addresses preceeded by a space, in order to stop
	 * mangling HTML code.
	 *
	 * The Following function was taken from the Scriplets area of http://www.phpwizard.net, and was written by Tobias Ratschiller.
	 *   Visit phpwizard.net today, its an excellent site!
	 */
	 // original make_clickable
	function makeClickable($text) {
	    $ret = eregi_replace(" ([[:alnum:]]+)://([^[:space:]]*)([[:alnum:]#?/&=])", " <a href='\\1://\\2\\3' target='_blank' target='_new'>\\1://\\2\\3</a>", $text);
		$ret = eregi_replace(" (([a-z0-9_]|\\-|\\.)+@([^[:space:]]*)([[:alnum:]-]))", " <a href='mailto:\\1' target='_new'>\\1</a>", $ret);
		return $ret;
	}

	/**
	 * Nathan Codding - August 24, 2000.
	 * Takes a string, and does the reverse of the PHP standard function
	 * htmlspecialchars().
	 */
	 //  Original undo_htmlspecialchars
    function undoHtmlSpecialChars($input) {
		$input = preg_replace("/&gt;/i", ">", $input);
        $input = preg_replace("/&lt;/i", "<", $input);
        $input = preg_replace("/&quot;/i", "\"", $input);
        $input = preg_replace("/&amp;/i", "&", $input);
		return $input;
	}

	/*********************************************************/
	/* text filter                                           */
	/*********************************************************/
	// Original check_words
	function checkWords($Message) { 
		// removes "bad" words according to configuration in config.php 
		global $phpEx;
		//Very odd bug fix 
		include("config.$phpEx"); 
		global $EditedMessage; 
		$EditedMessage = $Message; 
		if ($CensorMode != 0) { 
			if (is_array($CensorList)) { 
				$Replacement = $CensorReplace; 
				if ($CensorMode == 1) { # Exact match 
				    for ($i = 0; $i < count($CensorList); $i++) { 
						$EditedMessage = eregi_replace("$CensorList[$i]([^a-zA-Z0-9])","$Replacement\\1",$EditedMessage); 
					} 
				} elseif ($CensorMode == 2) { # Word beginning 
				    for ($i = 0; $i < count($CensorList); $i++) { 
						$EditedMessage = eregi_replace("(^|[^[:alnum:]])$CensorList[$i]","\\1$Replacement",$EditedMessage); 
					} 
				} elseif ($CensorMode == 3) { # Word fragment 
				    for ($i = 0; $i < count($CensorList); $i++) { 
						$EditedMessage = eregi_replace("$CensorList[$i]","$Replacement",$EditedMessage); 
					} 
				} 
			} 
		} 
		return $EditedMessage;
	} 
    
	//Original check_html
	function checkHtml ($str, $strip="") {
		// The core of this code has been lifted from phpslash
		// which is licenced under the GPL.
		global $phpEx;
		include("config.$phpEx");
		if ($strip == "nohtml") {
			$AllowableHTML=array('');
		}
		$str = stripslashes($str);
        $str = eregi_replace("<[[:space:]]*([^>]*)[[:space:]]*>", '<\\1>', $str);
		// Delete all spaces from html tags .
        $str = eregi_replace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?[[:space:]]*([^\" >]*)[[:space:]]*\"?[^>]*>", '<a href="\\1">', $str); # "
		// Delete all attribs from Anchor, except an href, double quoted.
        $str = eregi_replace("<img?", '', $str); # "
		$tmp = "";
        while (ereg("<(/?[[:alpha:]]*)[[:space:]]*([^>]*)>",$str,$reg)) {
			$i = strpos($str,$reg[0]);
			$l = strlen($reg[0]);
			if ($reg[1][0] == "/") {
				$tag = strtolower(substr($reg[1],1));
			} else {
				$tag = strtolower($reg[1]);
			}
			if ($a = $AllowableHTML[$tag]) {
				if ($reg[1][0] == "/") {
					$tag = "</$tag>";
				} elseif (($a == 1) || ($reg[2] == "")) {
					$tag = "<$tag>";
				} else {
					# Place here the double quote fix function.
					$attrb_list=delQuotes($reg[2]);
					$tag = "<$tag" . $attrb_list . ">";
				} # Attribs in tag allowed
			} else {
				$tag = "";
			}
			$tmp .= substr($str,0,$i) . $tag;
			$str = substr($str,$i+$l);
		}
        $str = $tmp . $str;
        return $str;
        exit;
        // Squash PHP tags unconditionally
        $str = ereg_replace("<\?","",$str);
        return $str;
	}


}
?>